# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class K8SInstaller(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cluster_id': 'str',
        'cluster_id_old': 'str',
        'content': 'str',
        'created_millis': 'int',
        'custom_resources': 'dict(str, str)',
        'id': 'str',
        'installation_parameters': 'dict(str, str)',
        'installer_type': 'str',
        'org_id': 'str',
        'owner_id': 'str',
        'owner_id_old': 'str',
        'retry_count': 'int',
        'rollback_on_fail': 'bool',
        'state': 'str',
        'steps': 'list[K8SInstallerSteps]',
        'updated_millis': 'int'
    }

    attribute_map = {
        'cluster_id': 'clusterId',
        'cluster_id_old': 'clusterIdOld',
        'content': 'content',
        'created_millis': 'createdMillis',
        'custom_resources': 'customResources',
        'id': 'id',
        'installation_parameters': 'installationParameters',
        'installer_type': 'installerType',
        'org_id': 'orgId',
        'owner_id': 'ownerId',
        'owner_id_old': 'ownerIdOld',
        'retry_count': 'retryCount',
        'rollback_on_fail': 'rollbackOnFail',
        'state': 'state',
        'steps': 'steps',
        'updated_millis': 'updatedMillis'
    }

    def __init__(self, cluster_id=None, cluster_id_old=None, content=None, created_millis=None, custom_resources=None, id=None, installation_parameters=None, installer_type=None, org_id=None, owner_id=None, owner_id_old=None, retry_count=None, rollback_on_fail=None, state=None, steps=None, updated_millis=None):  # noqa: E501
        """K8SInstaller - a model defined in Swagger"""  # noqa: E501
        self._cluster_id = None
        self._cluster_id_old = None
        self._content = None
        self._created_millis = None
        self._custom_resources = None
        self._id = None
        self._installation_parameters = None
        self._installer_type = None
        self._org_id = None
        self._owner_id = None
        self._owner_id_old = None
        self._retry_count = None
        self._rollback_on_fail = None
        self._state = None
        self._steps = None
        self._updated_millis = None
        self.discriminator = None
        if cluster_id is not None:
            self.cluster_id = cluster_id
        if cluster_id_old is not None:
            self.cluster_id_old = cluster_id_old
        if content is not None:
            self.content = content
        if created_millis is not None:
            self.created_millis = created_millis
        if custom_resources is not None:
            self.custom_resources = custom_resources
        if id is not None:
            self.id = id
        if installation_parameters is not None:
            self.installation_parameters = installation_parameters
        if installer_type is not None:
            self.installer_type = installer_type
        if org_id is not None:
            self.org_id = org_id
        if owner_id is not None:
            self.owner_id = owner_id
        if owner_id_old is not None:
            self.owner_id_old = owner_id_old
        if retry_count is not None:
            self.retry_count = retry_count
        if rollback_on_fail is not None:
            self.rollback_on_fail = rollback_on_fail
        if state is not None:
            self.state = state
        if steps is not None:
            self.steps = steps
        if updated_millis is not None:
            self.updated_millis = updated_millis

    @property
    def cluster_id(self):
        """Gets the cluster_id of this K8SInstaller.  # noqa: E501


        :return: The cluster_id of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._cluster_id

    @cluster_id.setter
    def cluster_id(self, cluster_id):
        """Sets the cluster_id of this K8SInstaller.


        :param cluster_id: The cluster_id of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._cluster_id = cluster_id

    @property
    def cluster_id_old(self):
        """Gets the cluster_id_old of this K8SInstaller.  # noqa: E501


        :return: The cluster_id_old of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._cluster_id_old

    @cluster_id_old.setter
    def cluster_id_old(self, cluster_id_old):
        """Sets the cluster_id_old of this K8SInstaller.


        :param cluster_id_old: The cluster_id_old of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._cluster_id_old = cluster_id_old

    @property
    def content(self):
        """Gets the content of this K8SInstaller.  # noqa: E501


        :return: The content of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this K8SInstaller.


        :param content: The content of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._content = content

    @property
    def created_millis(self):
        """Gets the created_millis of this K8SInstaller.  # noqa: E501


        :return: The created_millis of this K8SInstaller.  # noqa: E501
        :rtype: int
        """
        return self._created_millis

    @created_millis.setter
    def created_millis(self, created_millis):
        """Sets the created_millis of this K8SInstaller.


        :param created_millis: The created_millis of this K8SInstaller.  # noqa: E501
        :type: int
        """

        self._created_millis = created_millis

    @property
    def custom_resources(self):
        """Gets the custom_resources of this K8SInstaller.  # noqa: E501


        :return: The custom_resources of this K8SInstaller.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_resources

    @custom_resources.setter
    def custom_resources(self, custom_resources):
        """Sets the custom_resources of this K8SInstaller.


        :param custom_resources: The custom_resources of this K8SInstaller.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_resources = custom_resources

    @property
    def id(self):
        """Gets the id of this K8SInstaller.  # noqa: E501


        :return: The id of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this K8SInstaller.


        :param id: The id of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def installation_parameters(self):
        """Gets the installation_parameters of this K8SInstaller.  # noqa: E501


        :return: The installation_parameters of this K8SInstaller.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._installation_parameters

    @installation_parameters.setter
    def installation_parameters(self, installation_parameters):
        """Sets the installation_parameters of this K8SInstaller.


        :param installation_parameters: The installation_parameters of this K8SInstaller.  # noqa: E501
        :type: dict(str, str)
        """

        self._installation_parameters = installation_parameters

    @property
    def installer_type(self):
        """Gets the installer_type of this K8SInstaller.  # noqa: E501


        :return: The installer_type of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._installer_type

    @installer_type.setter
    def installer_type(self, installer_type):
        """Sets the installer_type of this K8SInstaller.


        :param installer_type: The installer_type of this K8SInstaller.  # noqa: E501
        :type: str
        """
        allowed_values = ["CLUSTER", "NAMESPACE", "SUPERVISOR_CLUSTER", "SUPERVISOR_NAMESPACE"]  # noqa: E501
        if installer_type not in allowed_values:
            raise ValueError(
                "Invalid value for `installer_type` ({0}), must be one of {1}"  # noqa: E501
                .format(installer_type, allowed_values)
            )

        self._installer_type = installer_type

    @property
    def org_id(self):
        """Gets the org_id of this K8SInstaller.  # noqa: E501


        :return: The org_id of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this K8SInstaller.


        :param org_id: The org_id of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def owner_id(self):
        """Gets the owner_id of this K8SInstaller.  # noqa: E501


        :return: The owner_id of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._owner_id

    @owner_id.setter
    def owner_id(self, owner_id):
        """Sets the owner_id of this K8SInstaller.


        :param owner_id: The owner_id of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._owner_id = owner_id

    @property
    def owner_id_old(self):
        """Gets the owner_id_old of this K8SInstaller.  # noqa: E501


        :return: The owner_id_old of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._owner_id_old

    @owner_id_old.setter
    def owner_id_old(self, owner_id_old):
        """Sets the owner_id_old of this K8SInstaller.


        :param owner_id_old: The owner_id_old of this K8SInstaller.  # noqa: E501
        :type: str
        """

        self._owner_id_old = owner_id_old

    @property
    def retry_count(self):
        """Gets the retry_count of this K8SInstaller.  # noqa: E501


        :return: The retry_count of this K8SInstaller.  # noqa: E501
        :rtype: int
        """
        return self._retry_count

    @retry_count.setter
    def retry_count(self, retry_count):
        """Sets the retry_count of this K8SInstaller.


        :param retry_count: The retry_count of this K8SInstaller.  # noqa: E501
        :type: int
        """

        self._retry_count = retry_count

    @property
    def rollback_on_fail(self):
        """Gets the rollback_on_fail of this K8SInstaller.  # noqa: E501


        :return: The rollback_on_fail of this K8SInstaller.  # noqa: E501
        :rtype: bool
        """
        return self._rollback_on_fail

    @rollback_on_fail.setter
    def rollback_on_fail(self, rollback_on_fail):
        """Sets the rollback_on_fail of this K8SInstaller.


        :param rollback_on_fail: The rollback_on_fail of this K8SInstaller.  # noqa: E501
        :type: bool
        """

        self._rollback_on_fail = rollback_on_fail

    @property
    def state(self):
        """Gets the state of this K8SInstaller.  # noqa: E501


        :return: The state of this K8SInstaller.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this K8SInstaller.


        :param state: The state of this K8SInstaller.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREATED", "INSTALLING", "NOT_READY", "READY", "UNINSTALLING", "UNINSTALLED", "FAILED", "DELETING"]  # noqa: E501
        if state not in allowed_values:
            raise ValueError(
                "Invalid value for `state` ({0}), must be one of {1}"  # noqa: E501
                .format(state, allowed_values)
            )

        self._state = state

    @property
    def steps(self):
        """Gets the steps of this K8SInstaller.  # noqa: E501


        :return: The steps of this K8SInstaller.  # noqa: E501
        :rtype: list[K8SInstallerSteps]
        """
        return self._steps

    @steps.setter
    def steps(self, steps):
        """Sets the steps of this K8SInstaller.


        :param steps: The steps of this K8SInstaller.  # noqa: E501
        :type: list[K8SInstallerSteps]
        """

        self._steps = steps

    @property
    def updated_millis(self):
        """Gets the updated_millis of this K8SInstaller.  # noqa: E501


        :return: The updated_millis of this K8SInstaller.  # noqa: E501
        :rtype: int
        """
        return self._updated_millis

    @updated_millis.setter
    def updated_millis(self, updated_millis):
        """Sets the updated_millis of this K8SInstaller.


        :param updated_millis: The updated_millis of this K8SInstaller.  # noqa: E501
        :type: int
        """

        self._updated_millis = updated_millis

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(K8SInstaller, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, K8SInstaller):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
